diff --git a/arch/arm/boot/dts/berlin2.dtsi b/arch/arm/boot/dts/berlin2.dtsi
index 6194857f8a02..02c9b8b5b633 100644
--- a/arch/arm/boot/dts/berlin2.dtsi
+++ b/arch/arm/boot/dts/berlin2.dtsi
@@ -188,7 +188,6 @@ gpio0: gpio@400 {
 				#size-cells = <0>;
 
 				porta: gpio-port@0 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <8>;
@@ -206,7 +205,6 @@ gpio1: gpio@800 {
 				#size-cells = <0>;
 
 				portb: gpio-port@1 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <8>;
@@ -224,7 +222,6 @@ gpio2: gpio@c00 {
 				#size-cells = <0>;
 
 				portc: gpio-port@2 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <8>;
@@ -242,7 +239,6 @@ gpio3: gpio@1000 {
 				#size-cells = <0>;
 
 				portd: gpio-port@3 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <8>;
@@ -443,7 +439,6 @@ sm_gpio1: gpio@5000 {
 				#size-cells = <0>;
 
 				portf: gpio-port@5 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <8>;
@@ -458,7 +453,6 @@ sm_gpio0: gpio@c000 {
 				#size-cells = <0>;
 
 				porte: gpio-port@4 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <8>;
diff --git a/arch/arm/boot/dts/berlin2cd.dtsi b/arch/arm/boot/dts/berlin2cd.dtsi
index 6f30d7eb3b41..f7698ab97abf 100644
--- a/arch/arm/boot/dts/berlin2cd.dtsi
+++ b/arch/arm/boot/dts/berlin2cd.dtsi
@@ -178,7 +178,6 @@ gpio0: gpio@400 {
 				#size-cells = <0>;
 
 				porta: gpio-port@0 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <8>;
@@ -196,7 +195,6 @@ gpio1: gpio@800 {
 				#size-cells = <0>;
 
 				portb: gpio-port@1 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <8>;
@@ -214,7 +212,6 @@ gpio2: gpio@c00 {
 				#size-cells = <0>;
 
 				portc: gpio-port@2 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <8>;
@@ -232,7 +229,6 @@ gpio3: gpio@1000 {
 				#size-cells = <0>;
 
 				portd: gpio-port@3 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <8>;
@@ -470,7 +466,6 @@ sm_gpio1: gpio@5000 {
 				#size-cells = <0>;
 
 				portf: gpio-port@5 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <8>;
@@ -515,7 +510,6 @@ sm_gpio0: gpio@c000 {
 				#size-cells = <0>;
 
 				porte: gpio-port@4 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <8>;
diff --git a/arch/arm/boot/dts/berlin2q.dtsi b/arch/arm/boot/dts/berlin2q.dtsi
index b6a0acac6836..831505b47e27 100644
--- a/arch/arm/boot/dts/berlin2q.dtsi
+++ b/arch/arm/boot/dts/berlin2q.dtsi
@@ -249,7 +249,6 @@ gpio0: gpio@400 {
 				#size-cells = <0>;
 
 				porta: gpio-port@0 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <32>;
@@ -267,7 +266,6 @@ gpio1: gpio@800 {
 				#size-cells = <0>;
 
 				portb: gpio-port@1 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <32>;
@@ -285,7 +283,6 @@ gpio2: gpio@c00 {
 				#size-cells = <0>;
 
 				portc: gpio-port@2 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <32>;
@@ -303,7 +300,6 @@ gpio3: gpio@1000 {
 				#size-cells = <0>;
 
 				portd: gpio-port@3 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <32>;
@@ -549,7 +545,6 @@ sm_gpio1: gpio@5000 {
 				#size-cells = <0>;
 
 				portf: gpio-port@5 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <32>;
@@ -610,7 +605,6 @@ sm_gpio0: gpio@c000 {
 				#size-cells = <0>;
 
 				porte: gpio-port@4 {
-					compatible = "snps,dw-apb-gpio-port";
 					gpio-controller;
 					#gpio-cells = <2>;
 					snps,nr-gpios = <32>;